diff -cprN head/src/test/regress/sql/partition.sql work/src/test/regress/sql/partition.sql
*** head/src/test/regress/sql/partition.sql	1970-01-01 09:00:00.000000000 +0900
--- work/src/test/regress/sql/partition.sql	2010-01-18 14:38:33.997046457 +0900
***************
*** 0 ****
--- 1,188 ----
+ --
+ -- RANGE PARTITION with timestamp
+ --
+ CREATE TABLE sales_range (
+   salesman_id       numeric(5),
+   salesman_name     varchar(30),
+   sales_state       varchar(20),
+   sales_date        timestamp
+ )
+ PARTITION BY RANGE (sales_date)
+ (
+   PARTITION sales_2006 VALUES LESS THAN ('2007-01-01'),
+   PARTITION sales_2007 VALUES LESS THAN ('2008-01-01'),
+   PARTITION sales_2008 VALUES LESS THAN ('2009-01-01'),
+   PARTITION sales_max  VALUES LESS THAN (MAXVALUE)
+ );
+ \d+ sales_range
+ \d+ sales_2006
+ \d+ sales_2007
+ \d+ sales_2008
+ \d+ sales_max
+ SELECT inhrelid::regclass, inhseqno, inhvalues FROM pg_inherits WHERE inhparent = 'sales_range'::regclass ORDER BY 1;
+ SELECT partrelid::regclass, partkind, pg_get_expr(partkey, partrelid) FROM pg_partition;
+ DROP TABLE sales_range CASCADE;
+ 
+ --
+ -- CREATE TABLE + ALTER TABLE PARTITION BY RANGE + ATTACH PARTITION
+ --
+ CREATE TABLE sales_range (
+   salesman_id       numeric(5),
+   salesman_name     varchar(30),
+   sales_state       varchar(20),
+   sales_date        timestamp
+ );
+ ALTER TABLE sales_range PARTITION BY RANGE (sales_date) timestamp_ops
+ (
+   PARTITION sales_2006 VALUES LESS THAN '2007-01-01',
+   PARTITION sales_2007 VALUES LESS THAN '2008-01-01'
+ );
+ CREATE TABLE sales_2008 (LIKE sales_range INCLUDING ALL);
+ ALTER TABLE sales_range ATTACH PARTITION sales_2008 VALUES LESS THAN '2009-01-01';
+ 
+ -- ERROR: cannot split partition "sales_2008"
+ CREATE PARTITION sales_error ON sales_range VALUES LESS THAN '2008-06-06';
+ 
+ CREATE TABLE sales_max  (LIKE sales_range INCLUDING ALL);
+ ALTER TABLE sales_range ATTACH PARTITION sales_max  VALUES LESS THAN MAXVALUE;
+ 
+ \d+ sales_range
+ \d+ sales_2006
+ \d+ sales_2007
+ \d+ sales_2008
+ \d+ sales_max
+ SELECT inhrelid::regclass, inhseqno, inhvalues FROM pg_inherits WHERE inhparent = 'sales_range'::regclass ORDER BY 1;
+ SELECT partrelid::regclass, partkind, pg_get_expr(partkey, partrelid) FROM pg_partition;
+ 
+ -- ERROR: cannot add partition to "sales_range", that has an overflow partition
+ CREATE PARTITION sales_error ON sales_range VALUES LESS THAN '2008-06-06';
+ -- ERROR: multiple partition keys for table "sales_range" are not allowed
+ ALTER TABLE sales_range PARTITION BY RANGE (salesman_id);
+ -- ERROR: cannot add LIST partition "sales_error" to RANGE partitioned table "sales_range"
+ CREATE PARTITION sales_error ON sales_range VALUES IN ('list');
+ 
+ -- NO PARTITION will drop all inhvalues.
+ ALTER TABLE sales_range NO PARTITION;
+ SELECT inhrelid::regclass, inhseqno, inhvalues FROM pg_inherits WHERE inhparent = 'sales_range'::regclass ORDER BY 1;
+ SELECT partrelid::regclass, partkind, pg_get_expr(partkey, partrelid) FROM pg_partition;
+ DROP TABLE sales_range CASCADE;
+ 
+ --
+ -- 1000 RANGE PARTITIONS
+ --
+ CREATE TABLE sales_range (
+   salesman_id       numeric(5),
+   salesman_name     varchar(30),
+   sales_state       varchar(20),
+   sales_date        timestamp
+ );
+ ALTER TABLE sales_range PARTITION BY RANGE (sales_date);
+ DO
+ $$
+ BEGIN
+   FOR i IN 1..1000 LOOP
+     EXECUTE 'CREATE PARTITION sales_' || i
+          || ' ON sales_range VALUES LESS THAN '
+          || quote_literal('2000-01-01'::timestamp + i * '1 day'::interval);
+   END LOOP;
+ END;
+ $$;
+ CREATE PARTITION sales_max ON sales_range VALUES LESS THAN MAXVALUE;
+ SET client_min_messages = WARNING;
+ DROP TABLE sales_range CASCADE;
+ RESET client_min_messages;
+ 
+ --
+ -- LIST PARTITION with varchar
+ --
+ CREATE TABLE sales_list (
+   salesman_id       numeric(5),
+   salesman_name     varchar(30),
+   sales_state       varchar(20),
+   sales_date        timestamp
+ )
+ PARTITION BY LIST (sales_state) varchar_ops
+ (
+   PARTITION sales_asia  VALUES ('asia'),
+   PARTITION sales_euro  VALUES ('eu'),
+   PARTITION sales_us    VALUES ('usa', 'canada'),
+   PARTITION sales_other VALUES (DEFAULT)
+ );
+ \d+ sales_list
+ \d+ sales_asia
+ \d+ sales_euro
+ \d+ sales_us
+ \d+ sales_other
+ SELECT inhrelid::regclass, inhseqno, inhvalues FROM pg_inherits WHERE inhparent = 'sales_list'::regclass ORDER BY 1;
+ SELECT partrelid::regclass, partkind, pg_get_expr(partkey, partrelid) FROM pg_partition;
+ DROP TABLE sales_list CASCADE;
+ 
+ --
+ -- 1000 LIST PARTITIONS
+ --
+ CREATE TABLE sales_list (
+   salesman_id       numeric(5),
+   salesman_name     varchar(30),
+   sales_state       varchar(20),
+   sales_date        timestamp
+ );
+ ALTER TABLE sales_list PARTITION BY LIST (lower(sales_state)) text_ops;
+ DO
+ $$
+ BEGIN
+   FOR i IN 1..1000 LOOP
+     EXECUTE 'CREATE PARTITION sales_' || i
+          || ' ON sales_list VALUES (' || quote_literal(i) || ')';
+   END LOOP;
+ END;
+ $$;
+ 
+ -- ERROR: partition values overlapped with "sales_123"
+ CREATE PARTITION sales_error ON sales_list VALUES ('1001', '123');
+ 
+ CREATE PARTITION sales_other ON sales_list VALUES DEFAULT;
+ SET client_min_messages = WARNING;
+ DROP TABLE sales_list CASCADE;
+ RESET client_min_messages;
+ 
+ --
+ -- LIST PARTITION with boolean
+ --
+ CREATE TABLE answers (
+   id     integer,
+   answer boolean
+ )
+ PARTITION BY LIST (answer)
+ (
+   PARTITION ans_yes     VALUES (true),
+   PARTITION ans_no      VALUES (false)
+ );
+ 
+ -- ERROR: partition key must not be NULL
+ CREATE PARTITION ans_unknown ON answers VALUES (NULL);
+ 
+ CREATE PARTITION ans_unknown ON answers VALUES (DEFAULT);
+ \d+ answers
+ 
+ -- INSERTs with conditional triggers
+ CREATE FUNCTION insert_into() RETURNS trigger AS
+ $$
+ BEGIN
+   EXECUTE 'INSERT INTO ' || quote_ident(TG_ARGV[0]) || ' VALUES($1.*)' USING NEW;
+   RETURN NULL;
+ END;
+ $$
+ LANGUAGE plpgsql;
+ 
+ CREATE TRIGGER insert_yes BEFORE INSERT ON answers FOR EACH ROW
+   WHEN (NEW.answer) EXECUTE PROCEDURE insert_into('ans_yes');
+ CREATE TRIGGER insert_no BEFORE INSERT ON answers FOR EACH ROW
+   WHEN (NOT NEW.answer) EXECUTE PROCEDURE insert_into('ans_no');
+ CREATE TRIGGER insert_unknown BEFORE INSERT ON answers FOR EACH ROW
+   WHEN (NEW.answer IS NULL) EXECUTE PROCEDURE insert_into('ans_unknown');
+ 
+ INSERT INTO answers VALUES(1, true), (2, false), (3, NULL);
+ SELECT tableoid::regclass, * FROM answers ORDER BY id;
+ 
+ DROP TABLE answers CASCADE;
+ DROP FUNCTION insert_into();